/*
 * Copyright (C) 2023, Bjørn D. Rasmussen, BearWare.dk
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef AUDIOPREPROCESSORDLG_H
#define AUDIOPREPROCESSORDLG_H

#include "ui_audiopreprocessor.h"

#include "common.h"

class AudioPreprocessorDlg : public QDialog {

    Q_OBJECT

public:
    AudioPreprocessorDlg(AudioPreprocessor preprocess, QWidget* parent);

    AudioPreprocessor m_preprocess = {};

private:
    void showSettings();

    void slotAccepted();
    void slotDefaultTTPreprocessor(bool);
    void slotDefaultSpeexDSP(bool);

private:
    Ui::AudioPreprocessorDlg ui;
};

#endif // AUDIOPREPROCESSORDLG_H
